<?php
  global $SITEURL;
  if (!isset($_POST['save']) && isset($_GET['undo'])) {
    $dir = GSBACKUPSPATH . 'i18n_navigation/';
	  $dir_handle = @opendir($dir);
    if ($dir_handle) {
      while (!isset($msg) && $filename = readdir($dir_handle)) {
        if (!is_dir($dir . $filename)) {
          if (!copy($dir . $filename, GSDATAPAGESPATH . $filename)) {
            $msg = i18n_r('i18n_navigation/UNDO_FAILURE');
          }
        }
      }
      if (!isset($msg)) {
        $msg = i18n_r('i18n_navigation/UNDO_SUCCESS');
        $success = true;
      }
    } else {
      $msg = i18n_r('i18n_navigation/UNDO_FAILURE');
    }      
  }
  $pages = array();
  $languages = array();
	$dir_handle = @opendir(GSDATAPAGESPATH) or die("Unable to open pages directory");
  $files_to_ignore = '/^('.i18n_get_property(I18N_PROP_URLS_TO_IGNORE, '').')\.xml$/';
	while ($filename = readdir($dir_handle)) {
    if (strrpos($filename,'.xml') === strlen($filename)-4 && !is_dir(GSDATAPAGESPATH . $filename) && !preg_match($files_to_ignore, $filename)) {
			$data = getXML(GSDATAPAGESPATH . $filename);
      if (strpos($filename,'_') !== false) {
        if (!isset($pages[$url])) {
          $pages[$url] = array('url' => $url, 'variants' => array(), 'exists' => false, 'title' => '', 'menuOrder' => 99, 'parent' => null);
        }
        $pages[$url]['variants'][] = (string) $data->url;
      } else {
        $url = '' . $data->url;
        if (!isset($pages[$url])) {
          $pages[$url] = array('url' => $url, 'variants' => array());
        }
        $pages[$url]['exists'] = true;
        $pages[$url]['parent'] = (string) $data->parent;
			  $pages[$url]['title'] = (string) $data->title;
        $pages[$url]['metak'] = (string) $data->meta;
        $pages[$url]['metad'] = (string) $data->metad;
			  $pages[$url]['menuStatus'] = (string) $data->menuStatus;
			  $pages[$url]['menuOrder'] = (int) $data->menuOrder;
        $pages[$url]['private'] = (string) $data->private;
        $pages[$url]['date'] = $data->pubDate;
      }
    }
	}
  if (isset($_POST['save'])) {
    $dir = GSBACKUPSPATH . 'i18n_navigation/';
    // create directory if necessary
    if (!file_exists($dir)) {
      @mkdir(substr($dir,0,strlen($dir)-1), 0777);
      $fp = @fopen($dir . '.htaccess', 'w');
      if ($fp) {
        fputs($fp, 'Deny from all');
        fclose($fp);
      }
    }
    // delete old backup files
	  $dir_handle = @opendir($dir);
    if ($dir_handle) while ($filename = readdir($dir_handle)) {
      if (!is_dir($dir . $filename)) unlink($dir . $filename);
    }

    $stack = array();
    for ($i=0; isset($_POST['page_'.$i.'_url']); $i++) {
      $url = $_POST['page_'.$i.'_url'];
      if (isset($pages[$url])) {
        $level = (int) $_POST['page_'.$i.'_level'];
        if ($level > count($stack)) $level = count($stack);
        $parent = $level <= 0 ? '' : $stack[$level-1];
        $menuOrder = count($stack) <= $level ? 0 : $pages[$stack[$level]]['menuOrder'] + 1;
        if ($parent != $pages[$url]['parent'] || $menuOrder != $pages[$url]['menuOrder']) {
          $pages[$url]['parent'] = $parent;
          $pages[$url]['menuOrder'] = $menuOrder;
          if (!isset($msg) && copy(GSDATAPAGESPATH . $url . '.xml', $dir . $url . '.xml')) {
      			$data = getXML(GSDATAPAGESPATH . $url . '.xml');
		        $xml = @new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><item></item>');
		        $xml->addChild('pubDate', (string) $data->pubDate);
            foreach ($data->children() as $child) {
              $name = $child->getName();
              if ($name != 'parent' && $name != 'menuOrder' && $name != 'pubDate') {
                $node = $xml->addChild($name);
                $node->addCData((string) $child);
              }
            }
		        $node = $xml->addChild('parent');
		        $node->addCData((string) $parent);
		        $node = $xml->addChild('menuOrder');
		        $node->addCData((string) $menuOrder);
         		XMLsave($xml, GSDATAPAGESPATH . $url . '.xml');
          } else {
            $msg = i18n_r('i18n_navigation/SAVE_FAILURE');
          }
        }
        while (count($stack) > $level) array_pop($stack);
        array_push($stack, $url);
      }
    }
    i18n_clear_cache();
    if (!isset($msg)) {
      $msg = i18n_r('i18n_navigation/SAVE_SUCCESS').' <a href="load.php?id=i18n_navigation&undo">' . i18n_r('UNDO') . '</a>';
      $success = true;
    }
  }
  sort($languages);
  // sort pages
  if (count($pages) > 0) foreach ($pages as &$page) {
    if ($page['parent'] && !isset($pages[$page['parent']])) $page['parent'] = null;
    $level = -1;
    $sort = '';
    for ($p = $page; $p && $level<20; $p = $p['parent'] ? $pages[$p['parent']] : null) {
      $sort = sprintf('%03d',$p['menuOrder']).$p['title'].' '.$sort;
      $level++;
    }
    $page['level'] = $level;
    $page['sort'] = $sort;
  }
  $pages = subval_sort($pages,'sort');
  $i = 0;
?>
		<h3 class="floated" style="float:left"><?php echo i18n_r('i18n_navigation/NAVIGATION'); ?></h3>
    <p class="clear"><?php i18n('i18n_navigation/NAVIGATION_DESCR'); ?></p>
    <form method="post" id="navigationForm" action="load.php?id=i18n_navigation">
			<table id="editnav" class="edittable highlight">
        <tbody>
        <?php
          foreach ($pages as &$page) {
            if ($page['exists']) {
              if ($page['title'] == '') $page['title'] = '[No Title] &nbsp;&raquo;&nbsp; <em>'. $page['url'] .'</em>'; 
        ?>
          <tr id="tr-<?php echo $page['url']; ?>">
            <td style="<?php echo 'padding-left:'.(4+20*$page['level']).'px;' . ($page['menuStatus'] != 'Y' ? 'color:gray;' : ''); ?>" >
              <input type="hidden" name="page_<?php echo $i; ?>_url" value="<?php echo $page['url']; ?>"/>
              <input type="hidden" name="page_<?php echo $i; ?>_level" value="<?php echo 0+$page['level']; ?>"/>
              <?php echo cl($page['title']); ?>
            </td>
            <td class="secondarylink"><a href="#" class="moveLeft" title="<?php i18n('i18n_navigation/OUTDENT'); ?>">&lt;</a></td>
            <td class="secondarylink"><a href="#" class="moveRight" title="<?php i18n('i18n_navigation/INDENT'); ?>">&gt;</a></td>
	          <td class="secondarylink">
	            <a title="<?php echo i18n_r('VIEWPAGE_TITLE').': '. cl($page['title']); ?>" target="_blank" href="<? echo find_url($page['url'],$page['parent']); ?>">#</a>
	          </td>
           </tr>
        <?php
              $i++;
            }
          }
        ?>
        </tbody>
			</table>
      <input type="submit" name="save" value="<?php i18n('i18n_navigation/SAVE_NAVIGATION'); ?>" class="submit"/>
    </form>
    <script type="text/javascript" src="<?php echo $SITEURL; ?>/plugins/i18n_navigation/js/jquery-ui.sort.min.js"></script>
    <script type="text/javascript">
      function getLevel($tr) {
        var level = parseInt($tr.find('[name$=level]').val());
        return level;
      }
      function setLevel($tr, level) {
        $tr.find('[name$=level]').val(level);
        $tr.find('td:first').css('padding-left', (4+20*level)+'px');
      }
      function moveLeft(e) {
        var $tr = $(e.target).closest('tr');
        var level = getLevel($tr);
        var nextlevel = getLevel($tr.next());
        if (level > 0 && nextlevel <= level) setLevel($tr, level-1); 
        e.preventDefault();
      }
      function moveRight(e) {
        var $tr = $(e.target).closest('tr'); 
        var level = getLevel($tr);
        var prevlevel = getLevel($tr.prev());
        if (prevlevel >= level) setLevel($tr, level+1);
        e.preventDefault();
      }
      function drop(e,ui) {
        var $tr = $(ui.item).closest('tr'); 
        var level = getLevel($tr);
        var prevlevel = getLevel($tr.prev());
        var nextlevel = getLevel($tr.next());
        if (prevlevel == null) {
          setLevel($tr, 0);
        } else if (prevlevel+1 < level) {
          setLevel($tr, prevlevel+1);
        } else if (nextlevel && level < nextlevel-1) {
          setLevel($tr, nextlevel-1);
        }
        renumberRows();
      }
      function renumberRows() {
        var oldlevel = -1;
        $('#editnav tbody tr').each(function(i,tr) {
          $tr = $(tr);
          $tr.find('input, select, textarea').each(function(k,elem) {
            var name = $(elem).attr('name').replace(/_\d+_/, '_'+(i)+'_');
            $(elem).attr('name', name);
          });
          var level = getLevel($tr);
          if (level > oldlevel+1) setLevel($tr, oldlevel+1); else setLevel($tr, level);
          oldlevel = level;
        });
      }
      $(function() {
        $('#editnav .moveLeft').click(moveLeft);
        $('#editnav .moveRight').click(moveRight);
        $('#editnav tbody').sortable({
          items:"tr", handle:'td',
          update:drop
        });
        renumberRows();
<?php if (isset($msg)) { ?>
        $('div.bodycontent').before('<div class="<?php echo $success ? 'updated' : 'error'?>" style="display:block;">'+<?php echo json_encode($msg); ?>+'</div>');
<?php } ?>
      });
    </script>

